## org.apache.lucene.analysis
Class Analyzer

    java.lang.Object
      org.apache.lucene.analysis.Analyzer

Direct Known Subclasses:
  BrazilianAnalyzer, ChineseAnalyzer, CJKAnalyzer, CzechAnalyzer, DutchAnalyzer, FrenchAnalyzer, GermanAnalyzer, GreekAnalyzer, KeywordAnalyzer, PatternAnalyzer, PerFieldAnalyzerWrapper, RussianAnalyzer, SimpleAnalyzer, SnowballAnalyzer, StandardAnalyzer, StopAnalyzer, ThaiAnalyzer, WhitespaceAnalyzer

    public abstract class Analyzer

extends Object

An Analyzer builds TokenStreams, which analyze text. It thus represents a policy for extracting index terms from text.

Typical implementations first build a Tokenizer, which breaks the stream of characters from the Reader into raw Tokens. One or more TokenFilters may then be applied to the output of the Tokenizer.

WARNING: You must override one of the methods defined by this class in your subclass or the Analyzer will enter an infinite loop.

Constructor Summary
`Analyzer()`

Method Summary
`int` `getPositionIncrementGap(String fieldName)` Invoked before indexing a Fieldable instance if terms have already been added to that field.
`protected Object` `getPreviousTokenStream()` Used by Analyzers that implement reusableTokenStream to retrieve previously saved TokenStreams for re-use by the same thread.
`TokenStream` `reusableTokenStream(String fieldName, Reader reader)` Creates a TokenStream that is allowed to be re-used from the previous time that the same thread called this method.
`protected void` `setPreviousTokenStream(Object obj)` Used by Analyzers that implement reusableTokenStream to save a TokenStream for later re-use by the same thread.
`abstract TokenStream` `tokenStream(String fieldName, Reader reader)` Creates a TokenStream which tokenizes all the text in the provided Reader.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Analyzer

    public Analyzer()

Method Detail

### tokenStream

    public abstract TokenStream tokenStream(String fieldName,
                                            Reader reader)

  Creates a TokenStream which tokenizes all the text in the provided Reader. Default implementation forwards to tokenStream(Reader) for compatibility with older version. Override to allow Analyzer to choose strategy based on document and/or field. Must be able to handle null field name for backward compatibility.

### reusableTokenStream

    public TokenStream reusableTokenStream(String fieldName,
                                           Reader reader)
                                    throws IOException

  Creates a TokenStream that is allowed to be re-used from the previous time that the same thread called this method. Callers that do not need to use more than one TokenStream at the same time from this analyzer should use this method for better performance.

  Throws:
    `IOException`

### getPreviousTokenStream

    protected Object getPreviousTokenStream()

  Used by Analyzers that implement reusableTokenStream to retrieve previously saved TokenStreams for re-use by the same thread.

### setPreviousTokenStream

    protected void setPreviousTokenStream(Object obj)

  Used by Analyzers that implement reusableTokenStream to save a TokenStream for later re-use by the same thread.

### getPositionIncrementGap

    public int getPositionIncrementGap(String fieldName)

  Invoked before indexing a Fieldable instance if terms have already been added to that field. This allows custom analyzers to place an automatic position increment gap between Fieldable instances using the same field name. The default value position increment gap is 0. With a 0 position increment gap and the typical default token position increment of 1, all terms in a field, including across Fieldable instances, are in successive positions, allowing exact PhraseQuery matches, for instance, across Fieldable instance boundaries.

  Parameters:
    `fieldName` - Fieldable name being indexed.
  Returns:
    position increment gap, added to the next token emitted from `tokenStream(String,Reader)`

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.